﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls;
using Telerik.WinControls.RadControlSpy;
using Telerik.WinControls.UI.Docking;

namespace _978660_RadDockAutoHide
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.radDock1.DockStateChanged += radDock1_DockStateChanged;
        }

        private void radDock1_DockStateChanged(object sender, Telerik.WinControls.UI.Docking.DockWindowEventArgs e)
        {
            if (e.DockWindow.DockState == DockState.Docked)
            {
                AutoHidePosition position = GetDockPostition(e.DockWindow);
                RadMessageBox.Show(position.ToString());
            }
        }

        public AutoHidePosition GetDockPostition(DockWindow window)
        {
            Type type = typeof(RadDock);
            MethodInfo mi = this.radDock1.GetType().GetMethod("GetAutoHidePosition", BindingFlags.Instance | BindingFlags.NonPublic);
            object res = mi.Invoke(this.radDock1, new object[] { (ToolTabStrip)this.radDock1[window.Name].TabStrip });
            AutoHidePosition aHPposition = (AutoHidePosition)res;

            return aHPposition;
        }
    }
}
